/* prependN.cpp times inserting n values at the beginning of a list
 *   against inserting n values at the beginning of a vector.
 *
 *  Author: Joel Adams, for Hands On C++.
 *  Date: November 1997.
 */

#include "Timer.h"                                   // Timer class
#include <vector>                                    // vector<>
#include <list>                                      // list<>
using namespace std;

// sets the number of times the test should be run
const int ITERATIONS = 1000;

double listTest (int n);
double vectorTest (int n);

int main()
{
  cout << "\nPrepending N values to empty containers.\n"
       << " Enter the number of values you want to insert: ";
  int n;
  cin >> n;
  cout << "Running test..." << endl;
  double listTimePerOp = listTest(n);
  double vectorTimePerOp = vectorTest(n);
  cout << "result prependN " << n << " list "  << listTimePerOp << endl;
  cout << "result prependN " << n << " vector " << vectorTimePerOp << endl;
}

double listTest (int n)
{
  Timer theTimer;
  theTimer.start();
  for (int iter = 0; iter < ITERATIONS; iter++)
    {
      list<int> theList;
      for (int i = 0; i < n; i++)
	theList.insert(theList.begin(), i);
    }
  theTimer.stop();
  return theTimer.seconds() / ITERATIONS;
}

double vectorTest (int n)
{
  Timer theTimer;
  theTimer.start();
  for (int iter = 0; iter < ITERATIONS; iter++)
    {
      vector<int> theVector;
      for (int i = 0; i < n; i++)
	theVector.insert(theVector.begin(), i);
    }
  theTimer.stop();
  return theTimer.seconds() / ITERATIONS;
}
